﻿using System;
using System.Windows.Media;
using PrivDH.Core.Helpers;
using PrivDH.Core.Managers;
using Styx;
using Styx.Common;
using Styx.CommonBot.Routines;
using Styx.WoWInternals.DBC;
using Styx.WoWInternals.WoWObjects;

using HKM = PrivDH.Core.Managers.HotKeysManager;
using U = PrivDH.Core.Unit;
using R = PrivDH.Rotation.Rotation;

namespace PrivDH
{
    public class PrivDH : CombatRoutine
    {
        private static readonly Version version = new Version(1, 0, 0);
        public override string Name => "Private Demon Hunter " + version;
        public override WoWClass Class => WoWClass.DemonHunter;
        public override CapabilityFlags SupportedCapabilities => CapabilityFlags.All;
        private static LocalPlayer Me => StyxWoW.Me;

        #region [Method] - Implementations
        private Styx.TreeSharp.Composite _preCombatBuffBehavior, _combatBuffBehavior, _combatBehavior;
        public override Styx.TreeSharp.Composite PreCombatBuffBehavior => _preCombatBuffBehavior ?? (_preCombatBuffBehavior = R.preCombatBuffing());
        public override Styx.TreeSharp.Composite CombatBuffBehavior => _combatBuffBehavior ?? (_combatBuffBehavior = R.combatBuffing());
        public override Styx.TreeSharp.Composite CombatBehavior => _combatBehavior ?? (_combatBehavior = R.rotationSelector());
        

        public override void Initialize()
        {
            Logging.Write(Colors.OrangeRed, "Hello {0}!", Me.Name);
            Logging.Write(Colors.White, "");
            Logging.Write(Colors.OrangeRed, "Best usage with: Enyo");
            Logging.Write(Colors.White, "");
            Logging.Write(Colors.OrangeRed, "Current Version:");
            Logging.Write(Colors.OrangeRed, "-- PrivDH v" + version + " --");
            Logging.Write(Colors.OrangeRed, "-- by Longzhua --");
            Logging.Write(Colors.OrangeRed, "-- A Private Demon Hunter Coumbat Routine --");
            HKM.registerHotKeys();
        }
        public override bool WantButton => true;
        public override void OnButtonPress() {Logging.Write(Colors.OrangeRed, "Coming Soon"); }
        public override void ShutDown() { HKM.removeHotkeys(); }
        #endregion

        #region [Method] - Pulse
        public override void Pulse()
        {
            if (!StyxWoW.IsInWorld || Me == null || !Me.IsValid || !Me.IsAlive)
                return;
            if (!Me.Combat)
                return;
            U.Cache();
        }
        #endregion

        internal static GroupLogic LocationContext
        {
            get
            {
                Map map = Me.CurrentMap;
                if (map.IsBattleground || map.IsArena)
                {
                    return GroupLogic.Battleground;
                }
                return map.IsDungeon ? GroupLogic.PvE : GroupLogic.Solo;
            }
            
        }
    }
}
