﻿using System.Diagnostics;
using System.Numerics;
using CommonBehaviors.Actions;
using PrivDH.Core;
using Styx;
using Styx.WoWInternals.WoWObjects;
using Styx.TreeSharp;

using SB = PrivDH.Core.Helpers.SpellBook;
using HkM = PrivDH.Core.Managers.HotKeysManager;

namespace PrivDH.Rotation
{
    class Rotation
    {
        private static LocalPlayer Me { get { return StyxWoW.Me; } }
        private static WoWUnit currentTarget { get { return StyxWoW.Me.CurrentTarget; } }

        #region [Method] - Combat Buffing
        public static Composite combatBuffing()
        {
            return new PrioritySelector(
                new Decorator(ret => HkM.manualOn || !Me.IsAlive || !Me.GotTarget, new ActionAlwaysSucceed()),
                new PrioritySelector(
                    SB.throwGlaive.Cast(reqs => Unit.isAttackable(currentTarget) && currentTarget.isUnitValid(30) && !Me.IsWithinMeleeRange)
                    ));
        }
        #endregion

        #region [Method] - Precombat Buffing
        public static Composite preCombatBuffing()
        {
            return new PrioritySelector(
                new Decorator(ret => HkM.manualOn || !Me.IsAlive || Me.IsCasting || Me.IsChanneling || Me.Mounted || Me.OnTaxi, new ActionAlwaysSucceed()),

                new PrioritySelector(
                    SB.throwGlaive.Cast(reqs => Unit.isAttackable(currentTarget) && currentTarget.isUnitValid(30) && !Me.IsWithinMeleeRange)
                    
                    ));
        }
        #endregion

        #region [Method] - Rotation Selector

        public static Composite rotationSelector()
        {
            return new PrioritySelector(
                new Decorator(ret => (HkM.manualOn || !Me.IsAlive || !Me.GotTarget), new ActionAlwaysSucceed()),
                new Switch<bool>(ret => HkM.aoeOn,
                    new SwitchArgument<bool>(true,
                        new PrioritySelector(
                           //Nothing Needed
                           //Reserved maybe for Dps Cooldowns?
                        )),
                    new SwitchArgument<bool>(false,
                        new PrioritySelector(

                            //Defensives
                            
                            SB.demonSpikes.Buff(reqs => Me.Combat && !Me.Mounted && Me.GotTarget
                                                          && Me.HealthPercent <= 80 && !Me.auraExists(SB.auraDemonSpikes), true),
                            SB.metamorphosis.Buff(reqs => Me.Combat && !Me.Mounted && Me.GotTarget
                                                          && Me.HealthPercent <= 35),
                            SB.empowerWards.Buff(reqs => Me.Combat && !Me.Mounted && Me.GotTarget
                                                          && Me.HealthPercent <= 80),
                            SB.fieryBrand.Cast(reqs => Me.Combat && !Me.Mounted && Me.GotTarget
                                                          && Me.HealthPercent <= 60 || Unit.CountEnemiesInRange(Me.Location, 5) >= 4),
                            
                            //Dps
                            SB.soulCarver.Cast(reqs => Me.IsWithinMeleeRange && Unit.isAttackable(currentTarget) && Me.IsActuallyInCombat),
                            SB.felDevastation.Cast(reqs => Unit.isAttackable(currentTarget) && currentTarget.isUnitValid(20)),
                            SB.soulCleave.Cast(reqs => Me.CurrentPain >= 80 && Unit.isAttackable(currentTarget) && !currentTarget.IsWithinMeleeRange),
                            SB.immolationAura.Buff(reqs => Unit.isAttackable(currentTarget) && currentTarget.IsWithinMeleeRange),
                            SB.felBlade.Cast(reqs => Unit.isAttackable(currentTarget) && currentTarget.isUnitValid(15)),
                            SB.sigilOfFlame.dropCast(ret => currentTarget, reqs => currentTarget.IsWithinMeleeRange && Unit.isAttackable(currentTarget) && currentTarget.isUnitValid(30)),
                            SB.shear.Cast(reqs => Unit.isAttackable(currentTarget) && currentTarget.IsWithinMeleeRange),
                            SB.throwGlaive.Cast(reqs => Unit.isAttackable(currentTarget) && currentTarget.isUnitValid(30) && !currentTarget.IsWithinMeleeRange)





                            ))));

        }
        #endregion
    }
}
